summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMatthias Maier <tamiko@gentoo.org>2018-06-30 23:04:00 -0500
committerMatthias Maier <tamiko@gentoo.org>2018-06-30 23:11:30 -0500
commit28e483383d8cce5578c91fedbe8db2ed8655fc32 (patch)
treecd9c487c6f6582a03238fa6c3d0dbc55e93f25a6
parentdev-python/backports-lzma: remove old (diff)
downloadgentoo-28e483383d8cce5578c91fedbe8db2ed8655fc32.tar.gz
gentoo-28e483383d8cce5578c91fedbe8db2ed8655fc32.tar.bz2
gentoo-28e483383d8cce5578c91fedbe8db2ed8655fc32.zip
dev-lang/julia: version bump to 0.6.3
Closes: https://bugs.gentoo.org/658196 Package-Manager: Portage-2.3.41, Repoman-2.3.9
-rw-r--r--dev-lang/julia/Manifest2
-rw-r--r--dev-lang/julia/julia-0.6.3.ebuild194
2 files changed, 196 insertions, 0 deletions
diff --git a/dev-lang/julia/Manifest b/dev-lang/julia/Manifest
index 5ddfad23e3c..8207d853db3 100644
--- a/dev-lang/julia/Manifest
+++ b/dev-lang/julia/Manifest
@@ -1,2 +1,4 @@
DIST julia-0.6.2-bundled.tar.gz 3508868 BLAKE2B b5b3f52d8036e5603b62606cd096f22f8a975f9cab2f9baad902c0208a81868359005e82a17e513a7705ec717750702cdc12ab476ffac3c1c38158f06d80ae99 SHA512 3a9a6cc43aab2eae6c57812287958e3a1ac1718d6fdf08e5ce7c8e8e8a62231fb4d7b6f064e2d6941ac750d8924f5cb37ae3ac4e2d18f366a82c94bdc9e6abe4
DIST julia-0.6.2.tar.gz 5592907 BLAKE2B d6d25f43cd650f6a079c4ba6fe533e6bdbf6a1123255d7651460e297ed3d35a832688e19efddf41c780fbda2eb861bc8ed5f7c59ea7efb5fdf490eb2e7a47f5d SHA512 679050463ed5825d34c477bd44cd91cfecc7d1735a2f52cc70b509afd9883cb60902861643266ecac5ba6cbb03f8fcdd12fc2e87dc41b9ed0eef813fa40610f1
+DIST julia-0.6.3-bundled.tar.gz 2099258 BLAKE2B dea1f5d37477e0a612e3901d7d568e8c4b350496f9d2b344cd7e2c2043ae30b4dd26b567803a2cb96d1ec4dbe2ba514fb08b925c695589746691887334330dd2 SHA512 d04cd55ba0dde08f253db3a388cf5ebe87cec8ae321a5af4c1c92f2680aa6e6ef2ebfa771ec74f8f1ff96409e2c0645476acf577859e8718eac4a581f097639d
+DIST julia-0.6.3.tar.gz 5542642 BLAKE2B cccd1ee2eb4d9f59382a0d1f6466e77c84b0542456c405c05b718bc8a39ff537a09760a523ee572fc9eee6797158aa00010fc4c931a80deac645fb1e45061c87 SHA512 f529bb30a17989234061cf4c3d87aecc6da720eb494efaca7be4ec1ed5eda60d440896fb76a45b6cb30205030256e7de765e8944f873b31d96f7c9ecac542db8
diff --git a/dev-lang/julia/julia-0.6.3.ebuild b/dev-lang/julia/julia-0.6.3.ebuild
new file mode 100644
index 00000000000..ba814f62191
--- /dev/null
+++ b/dev-lang/julia/julia-0.6.3.ebuild
@@ -0,0 +1,194 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+RESTRICT="test"
+
+inherit llvm pax-utils toolchain-funcs
+
+DESCRIPTION="High-performance programming language for technical computing"
+HOMEPAGE="https://julialang.org/"
+SRC_URI="
+ https://github.com/JuliaLang/${PN}/releases/download/v${PV}/${P}.tar.gz
+ https://dev.gentoo.org/~tamiko/distfiles/${P}-bundled.tar.gz
+"
+
+S="${WORKDIR}/julia"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~x86 ~amd64-linux ~x86-linux"
+IUSE=""
+
+# julia 0.6* is compatible with llvm-4
+RDEPEND="
+ sys-devel/llvm:4=
+ sys-devel/clang:4="
+LLVM_MAX_SLOT=4
+
+RDEPEND+="
+ dev-libs/double-conversion:0=
+ dev-libs/gmp:0=
+ dev-libs/libgit2:0=
+ dev-libs/mpfr:0=
+ dev-libs/openspecfun
+ sci-libs/arpack:0=
+ sci-libs/camd:0=
+ sci-libs/cholmod:0=
+ sci-libs/fftw:3.0=[threads]
+ sci-libs/openlibm:0=
+ sci-libs/spqr:0=
+ >=dev-libs/libpcre2-10.23:0=[jit]
+ sci-libs/umfpack:0=
+ sci-mathematics/glpk:0=
+ >=sys-libs/libunwind-1.1:7=
+ sys-libs/readline:0=
+ sys-libs/zlib:0=
+ >=virtual/blas-3.6
+ virtual/lapack"
+
+DEPEND="${RDEPEND}
+ dev-vcs/git
+ dev-util/patchelf
+ virtual/pkgconfig"
+
+PATCHES=(
+ "${FILESDIR}"/${PN}-0.6.0-fix_build_system.patch
+)
+
+src_prepare() {
+ mv "${WORKDIR}"/bundled/UnicodeData.txt doc || die
+ mkdir deps/srccache || die
+ mv "${WORKDIR}"/bundled/* deps/srccache || die
+ rmdir "${WORKDIR}"/bundled || die
+
+ default
+
+ # Sledgehammer:
+ # - prevent fetching of bundled stuff in compile and install phase
+ # - respect CFLAGS
+ # - respect EPREFIX and Gentoo specific paths
+ # - fix BLAS and LAPACK link interface
+
+ sed -i \
+ -e 's|git submodule|${EPREFIX}/bin/true|g' \
+ -e "s|GENTOOCFLAGS|${CFLAGS}|g" \
+ -e "s|/usr/include|${EPREFIX%/}/usr/include|g" \
+ deps/Makefile || die
+
+ local libblas="$($(tc-getPKG_CONFIG) --libs-only-l blas)"
+ libblas="${libblas%% *}"
+ libblas="lib${libblas#-l}"
+ local liblapack="$($(tc-getPKG_CONFIG) --libs-only-l lapack)"
+ liblapack="${liblapack%% *}"
+ liblapack="lib${liblapack#-l}"
+
+ sed -i \
+ -e "s|\(JULIA_EXECUTABLE = \)\(\$(JULIAHOME)/julia\)|\1 LD_LIBRARY_PATH=\$(BUILD)/$(get_libdir) \2|" \
+ -e "s|GENTOOCFLAGS|${CFLAGS}|g" \
+ -e "s|LIBDIR = lib|LIBDIR = $(get_libdir)|" \
+ -e "s|/usr/lib|${EPREFIX}/usr/$(get_libdir)|" \
+ -e "s|/usr/include|${EPREFIX}/usr/include|" \
+ -e "s|\$(BUILD)/lib|\$(BUILD)/$(get_libdir)|" \
+ -e "s|^JULIA_COMMIT = .*|JULIA_COMMIT = v${PV}|" \
+ -e "s|-lblas|$($(tc-getPKG_CONFIG) --libs blas)|" \
+ -e "s|= libblas|= ${libblas}|" \
+ -e "s|-llapack|$($(tc-getPKG_CONFIG) --libs lapack)|" \
+ -e "s|= liblapack|= ${liblapack}|" \
+ Make.inc || die
+
+ sed -i \
+ -e "s|,lib)|,$(get_libdir))|g" \
+ -e "s|\$(BUILD)/lib|\$(BUILD)/$(get_libdir)|g" \
+ Makefile || die
+
+ sed -i \
+ -e "s|ar -rcs|$(tc-getAR) -rcs|g" \
+ src/Makefile || die
+
+ # disable doc install starting git fetching
+ sed -i -e 's~install: $(build_depsbindir)/stringreplace $(BUILDROOT)/doc/_build/html/en/index.html~install: $(build_depsbindir)/stringreplace~' Makefile || die
+}
+
+src_configure() {
+ # julia does not play well with the system versions of dsfmt, libuv,
+ # and utf8proc
+
+ # USE_SYSTEM_LIBM=0 implies using external openlibm
+ cat <<-EOF > Make.user
+ USE_SYSTEM_DSFMT=0
+ USE_SYSTEM_LIBUV=0
+ USE_SYSTEM_PCRE=1
+ USE_SYSTEM_RMATH=0
+ USE_SYSTEM_UTF8PROC=0
+ USE_LLVM_SHLIB=1
+ USE_SYSTEM_ARPACK=1
+ USE_SYSTEM_BLAS=1
+ USE_SYSTEM_FFTW=1
+ USE_SYSTEM_GMP=1
+ USE_SYSTEM_GRISU=1
+ USE_SYSTEM_LAPACK=1
+ USE_SYSTEM_LIBGIT2=1
+ USE_SYSTEM_LIBM=0
+ USE_SYSTEM_LIBUNWIND=1
+ USE_SYSTEM_LLVM=1
+ USE_SYSTEM_MPFR=1
+ USE_SYSTEM_OPENLIBM=1
+ USE_SYSTEM_OPENSPECFUN=1
+ USE_SYSTEM_PATCHELF=1
+ USE_SYSTEM_READLINE=1
+ USE_SYSTEM_SUITESPARSE=1
+ USE_SYSTEM_ZLIB=1
+ VERBOSE=1
+ libdir="${EROOT}/usr/$(get_libdir)"
+ EOF
+
+}
+
+src_compile() {
+
+ # Julia accesses /proc/self/mem on Linux
+ addpredict /proc/self/mem
+
+ emake cleanall
+ emake VERBOSE=1 julia-release \
+ prefix="${EPREFIX}/usr" DESTDIR="${D}" \
+ CC="$(tc-getCC)" CXX="$(tc-getCXX)"
+ pax-mark m $(file usr/bin/julia-* | awk -F : '/ELF/ {print $1}')
+ emake
+}
+
+src_test() {
+ emake test
+}
+
+src_install() {
+ # Julia is special. It tries to find a valid git repository (that would
+ # normally be cloned during compilation/installation). Just make it
+ # happy...
+ git init && \
+ git config --local user.email "whatyoudoing@example.com" && \
+ git config --local user.name "Whyyyyyy" && \
+ git commit -a --allow-empty -m "initial" || die "git failed"
+
+ emake install \
+ prefix="${EPREFIX}/usr" DESTDIR="${D}" \
+ CC="$(tc-getCC)" CXX="$(tc-getCXX)"
+ cat > 99julia <<-EOF
+ LDPATH=${EROOT%/}/usr/$(get_libdir)/julia
+ EOF
+ doenvd 99julia
+
+ dodoc README.md
+
+ mv "${ED}"/usr/etc/julia "${ED}"/etc || die
+ rmdir "${ED}"/usr/etc || die
+ mv "${ED}"/usr/share/doc/julia/{examples,html} \
+ "${ED}"/usr/share/doc/${PF} || die
+ rmdir "${ED}"/usr/share/doc/julia || die
+ if [[ $(get_libdir) != lib ]]; then
+ mkdir -p "${ED}"/usr/$(get_libdir) || die
+ mv "${ED}"/usr/lib/julia "${ED}"/usr/$(get_libdir)/julia || die
+ fi
+}